# -*- coding: utf-8 -*-
# Generated by Django 1.11.4 on 2017-08-10 02:08
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion
import rdf_io.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
       ('rdf_io', '0003_load'),
    ]

    operations = [
        migrations.CreateModel(
            name='AttributeMapping',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('attr', rdf_io.models.EXPR_Field(help_text='for a literal, use "quoted" syntax, for nested attribute use syntax a.b.c', max_length=400, verbose_name='source attribute')),
                ('predicate', rdf_io.models.CURIE_Field(help_text='use a:b or full URI', max_length=200, verbose_name='predicate')),
                ('is_resource', models.BooleanField(verbose_name='as URI')),
            ],
        ),
        migrations.CreateModel(
            name='EmbeddedMapping',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('attr', rdf_io.models.EXPR_Field(help_text='for a literal, use "quoted" syntax, for nested attribute use syntax a.b.c', max_length=400, verbose_name='source attribute')),
                ('predicate', rdf_io.models.CURIE_Field(help_text='use a:b or full URI', max_length=200, verbose_name='predicate')),
                ('struct', models.TextField(help_text=' ";" separated list of <em>predicate</em> <em>attribute expr</em>  where attribute expr a model field or "literal" or <uri> - in future may be an embedded struct inside {} ', max_length=2000, verbose_name='object structure')),
                ('use_blank', models.BooleanField(default=True, verbose_name='embed as blank node')),
            ],
        ),
        migrations.CreateModel(
            name='GenericMetaProp',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('propname', models.CharField(max_length=250, verbose_name='name')),
                ('definition', models.TextField(blank=True, verbose_name='definition')),
            ],
        ),
        migrations.CreateModel(
            name='Namespace',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('uri', models.CharField(max_length=100, unique=True, verbose_name=b'uri')),
                ('prefix', models.CharField(max_length=8, unique=True, verbose_name=b'prefix')),
                ('notes', models.TextField(blank=True, verbose_name='change note')),
            ],
            options={
                'verbose_name': 'namespace',
                'verbose_name_plural': 'namespaces',
            },
        ),
        migrations.CreateModel(
            name='ObjectMapping',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(help_text='unique identifying label', max_length=250, unique=True, verbose_name='Name')),
                ('auto_push', models.BooleanField(help_text='set this to push updates to these object to the RDF store automatically', verbose_name='auto_push')),
                ('id_attr', models.CharField(help_text='for nested attribute use syntax a.b.c', max_length=250, verbose_name='ID Attribute')),
                ('target_uri_expr', rdf_io.models.EXPR_Field(help_text='for a literal, use "quoted" syntax, for nested attribute use syntax a.b.c', max_length=400, verbose_name='target namespace expression')),
                ('filter', rdf_io.models.FILTER_Field(blank=True, help_text='path=value, eg label__label_text="frog"', max_length=400, null=True, verbose_name='Filter')),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
            ],
        ),
        migrations.CreateModel(
            name='ObjectType',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('uri', rdf_io.models.CURIE_Field(help_text='use a:b or full URI', max_length=200, verbose_name='URI')),
                ('label', models.CharField(max_length=250, verbose_name='Label')),
            ],
        ),
        migrations.AddField(
            model_name='objectmapping',
            name='obj_type',
            field=models.ManyToManyField(blank=True, help_text='set this to generate a object rdf:type X statement', null=True, to='rdf_io.ObjectType'),
        ),
        migrations.AddField(
            model_name='genericmetaprop',
            name='namespace',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='rdf_io.Namespace', verbose_name='namespace'),
        ),
        migrations.AddField(
            model_name='embeddedmapping',
            name='scope',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='rdf_io.ObjectMapping'),
        ),
        migrations.AddField(
            model_name='attributemapping',
            name='scope',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='rdf_io.ObjectMapping'),
        ),
    ]
